#include "forms.h"
#include "wids_struct.h"
#include "pov_struct.h"

extern struct widget_ids wids;
extern struct pov_options pov;
 
extern const int GRP_X;
extern const int GRP_Y;
extern const int GRP_W;
extern const int GRP_H;

extern void YesNoCB();


void animation_group(void)
{
    FL_OBJECT *obj;
    

    wids.animation_grp = fl_bgn_group();

        obj = fl_add_text(FL_NORMAL_TEXT,
            GRP_X + 10, GRP_Y + 10, 150, 25, "Internal Animation Loop"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 20, GRP_Y + 40, 100, 25, "Initial Frame"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.init_frame_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 110, GRP_Y + 40, 50, 25, "");
            fl_set_input(wids.init_frame_input, "1");  

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 180, GRP_Y + 40, 130, 25, "Subset Start Frame"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.subset_start_frame_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 320, GRP_Y + 40, 50, 25, "");
 
        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 20, GRP_Y + 70, 100, 25, "Final Frame"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.final_frame_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 110, GRP_Y + 70, 50, 25, "");
            fl_set_input(wids.final_frame_input, "-1");  

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 180, GRP_Y + 70, 130, 25, "Subset End Frame"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.subset_end_frame_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 320, GRP_Y + 70, 50, 25, "");

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 300, GRP_Y + 100, 70, 25, "Cyclic Animation"); 
            fl_addto_choice(obj, "Off|On");
            fl_set_choice(obj, pov.cyclic_animation + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 13);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 300, GRP_Y + 130, 70, 25, "Field Rendering"); 
            fl_addto_choice(obj, "Off|Even|Odd");
            fl_set_choice(obj, pov.field_rendering + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 14);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 20, GRP_Y + 100, 100, 25, "Initial Clock"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.initial_clock_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 110, GRP_Y + 100, 50, 25, "");
            fl_set_input(wids.initial_clock_input, "0.00");  

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 20, GRP_Y + 130, 100, 25, "Final Clock"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.final_clock_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 110, GRP_Y + 130, 50, 25, "");
            fl_set_input(wids.final_clock_input, "1.00");  


        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 10, GRP_Y + 170, 150, 25, "External Animation Loop"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 20, GRP_Y + 200, 100, 25, "Clock"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
        wids.clock_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 110, GRP_Y + 200, 50, 25, "");
            fl_set_input(wids.clock_input, "0.00");

    fl_end_group(); 
        
}
