#include "forms.h"
#include "xfpovray.h"
#include "wids_struct.h"
#include "pov_struct.h"

extern void SetImageSizeCB();
extern void YesNoCB();
extern void SetMosaicCB();
extern void ClearPartialImageCB();

extern struct widget_ids wids;
extern struct pov_options pov;
 
extern const int GRP_X;
extern const int GRP_Y;
extern const int GRP_W;
extern const int GRP_H;


void output_group(void)
{
    FL_OBJECT *obj;
    char temp[10];

    
    wids.output_grp = fl_bgn_group();
    
	obj = fl_add_menu(FL_PULLDOWN_MENU, 
	    GRP_X + 10, GRP_Y + 10, 100, 25, "Image Width");
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_menu(obj, "50|60|70|80|90|100|150|200|640|800|1024|1280");
            fl_set_object_callback(obj, SetImageSizeCB, 1);

	wids.wid_width_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 120, GRP_Y + 10, 50, 25, "");
	    sprintf(temp, "%d", POV_WIDTH);
            fl_set_input(wids.wid_width_input, temp);    

	obj = fl_add_menu(FL_PULLDOWN_MENU, 
	    GRP_X + 10, GRP_Y + 40, 100, 25, "Image Height");
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_menu(obj, "50|60|70|80|90|100|150|200|480|600|768|1024");
            fl_set_object_callback(obj, SetImageSizeCB, 0);

	wids.wid_height_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 120, GRP_Y + 40, 50, 25, "");
	    sprintf(temp, "%d", POV_HEIGHT);
            fl_set_input(wids.wid_height_input, temp);  

	obj = fl_add_menu(FL_PULLDOWN_MENU, 
	    GRP_X + 220, GRP_Y + 10, 100, 25, "Mosaic Start");
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_menu(obj, "64|32|16|8|4|2| ");
            fl_set_object_callback(obj, SetMosaicCB, 0);
 
        wids.mosaic_start = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 340, GRP_Y + 10, 50, 25, "");
            fl_set_input(wids.mosaic_start, "");  

	obj = fl_add_menu(FL_PULLDOWN_MENU, 
	    GRP_X + 220, GRP_Y + 40, 100, 25, "Mosaic End");
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_menu(obj, "64|32|16|8|4|2| ");
            fl_set_object_callback(obj, SetMosaicCB, 1);

        wids.mosaic_end = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 340, GRP_Y + 40, 50, 25, "");
            fl_set_input(wids.mosaic_end, "");  
 
        obj = fl_add_text(FL_NORMAL_TEXT,
            GRP_X + 10, GRP_Y + 90, 150, 25, "Crop Image"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 10, GRP_Y + 120, 100, 25, "Start Column"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
 
        wids.wid_start_column = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 100, GRP_Y + 120, 50, 25, "");
            fl_set_input(wids.wid_start_column, "");  

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 170, GRP_Y + 120, 100, 25, "End Column"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
 
        wids.wid_end_column = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 250, GRP_Y + 120, 50, 25, "");
            fl_set_input(wids.wid_end_column, "");  

	obj = fl_add_button(FL_NORMAL_BUTTON, 
	    GRP_X + 320, GRP_Y + 120, 70, 25, "Clear"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_callback(obj, ClearPartialImageCB, 0);


        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 10, GRP_Y + 150, 100, 25, "Start Row"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
 
        wids.wid_start_row = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 100, GRP_Y + 150, 50, 25, "");
            fl_set_input(wids.wid_start_row, "");  

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 170, GRP_Y + 150, 100, 25, "End Row"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
 
        wids.wid_end_row = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 250, GRP_Y + 150, 50, 25, "");
            fl_set_input(wids.wid_end_row, "");

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 150, GRP_Y + 200, 70, 25, "Display During Render"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.display_during_render + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 0);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 320, GRP_Y + 200, 70, 25, "Palette"); 
            fl_addto_choice(obj, "True Color|High Color|Gray Scale");
            fl_set_choice(obj, pov.palette);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 15);
 
        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 150, GRP_Y + 230, 70, 25, "Output Image to File"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.output_to_file + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 5);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 320, GRP_Y + 230, 70, 25, "File Type"); 
            fl_addto_choice(obj, "TGA-24|RLE|PNG|PPM|System");
            fl_set_choice(obj, pov.output_filetype);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 16);
 
                 
        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 150, GRP_Y + 260, 70, 25, "Verbose"); 
            fl_addto_choice(obj, "Off|Low|High");
            fl_set_choice(obj, pov.verbose + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 1);
 
    fl_end_group(); 
        
}
