#include "forms.h"
#include "povray-defaults.h"
#include "wids_struct.h"
#include "pov_struct.h"

extern struct pov_options pov;
extern struct widget_ids wids;

extern void QualityCB();
extern void QualityResetCB();
extern void YesNoCB();
 
extern const int GRP_X;
extern const int GRP_Y;
extern const int GRP_W;
extern const int GRP_H;


void tracing_group(void)
{
    FL_OBJECT *obj;
    char temp[128];
    int bw = 90;
    int bh = 25;

    wids.tracing_grp = fl_bgn_group();

        wids.quality_slider = fl_add_valslider(FL_HOR_SLIDER, 
            GRP_X + 10, GRP_Y + 10, 220, 20, "");
            fl_set_slider_bounds (wids.quality_slider, 1, 11);
            fl_set_slider_value (wids.quality_slider, 9);
            fl_set_slider_step (wids.quality_slider, 1);
            fl_set_slider_precision (wids.quality_slider, 0);
            fl_set_slider_return (wids.quality_slider, 0);
            fl_set_object_lsize (wids.quality_slider, FL_NORMAL_SIZE);
            fl_set_object_callback (wids.quality_slider, QualityCB, 0);
            fl_set_object_lstyle(wids.quality_slider, FL_BOLD_STYLE);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 270, GRP_Y + 10, 50, 25, "Quality"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);

        obj = fl_add_button (FL_NORMAL_BUTTON, 
            GRP_X + 240, GRP_Y + 10, 20, 20, "@circle");
            fl_set_object_callback (obj, QualityResetCB, 0);
            fl_set_object_lsize(obj, FL_NORMAL_SIZE);
            fl_set_object_bw(obj, +2);

        wids.aa_slider = fl_add_valslider(FL_HOR_SLIDER, 
            GRP_X + 10, GRP_Y + 40, 220, 20, "");
            fl_set_slider_bounds (wids.aa_slider, 1, 9);
            fl_set_slider_value (wids.aa_slider, 3);
            fl_set_slider_step (wids.aa_slider, 1);
            fl_set_slider_precision (wids.aa_slider, 0);
            fl_set_slider_return (wids.aa_slider, 0);
            fl_set_object_lsize (wids.aa_slider, FL_NORMAL_SIZE);
            fl_set_object_callback (wids.aa_slider, QualityCB, 1);
            fl_set_object_lstyle(wids.aa_slider, FL_BOLD_STYLE);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 270, GRP_Y + 40, 100, 25, "Antialias Depth"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);

        obj = fl_add_button (FL_NORMAL_BUTTON, 
            GRP_X + 240, GRP_Y + 40, 20, 20, "@circle");
            fl_set_object_callback (obj, QualityResetCB, 1);
            fl_set_object_lsize(obj, FL_NORMAL_SIZE);
            fl_set_object_bw(obj, +2);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 80, bw, bh, "Antialias"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.antialias + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 2);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 170, GRP_Y + 80, 130, 25, "Antialias Threshold"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
 
        wids.antialias_threshold = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 305, GRP_Y + 80, 50, 25, "");
	    sprintf(temp, "%f", POV_ANTIALIAS_THRESHOLD);
            fl_set_input(wids.antialias_threshold, temp);
 
        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 110, bw, bh, "Method"); 
            fl_addto_choice(obj, "Non-Adaptive|Adaptive");
            fl_set_choice(obj, pov.aa_sampling_method);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 12);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 140, bw, bh, "Radiosity"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.radiosity + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 3);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 170, bw, bh, "Bounding"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.bounding + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 9);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 170, GRP_Y + 170, 130, 25, "Bounding Threshold"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

        sprintf(temp, "%d", pov.bounding_threshold); 
        wids.bounding_threshold = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 305, GRP_Y + 170, 50, 25, "");
            fl_set_input(wids.bounding_threshold, temp);
 
        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 200, bw, bh, "Light Buffer"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.light_buffer + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 10);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 230, bw, bh, "Vista Buffer"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.vista_buffer + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 11);

        obj = fl_add_choice(FL_NORMAL_CHOICE, 
            GRP_X + 80, GRP_Y + 260, bw, bh, "Jitter"); 
            fl_addto_choice(obj, "No|Yes");
            fl_set_choice(obj, pov.jitter + 1);
            fl_set_choice_fontstyle(obj, FL_BOLD_STYLE); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_boxtype(obj, FL_UP_BOX);
            fl_set_object_callback(obj, YesNoCB, 17);

        obj = fl_add_text(FL_NORMAL_TEXT, 
            GRP_X + 170, GRP_Y + 260, 130, 25, "Jitter Amount"); 
            fl_set_object_lstyle(obj, FL_BOLD_STYLE);
            fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
 
        wids.jitter_input = fl_add_input(FL_NORMAL_INPUT, 
	    GRP_X + 305, GRP_Y + 260, 50, 25, "");
	    sprintf(temp, "%f", POV_JITTER_AMOUNT);
            fl_set_input(wids.jitter_input, temp);

              
    fl_end_group(); 
        
}
